#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <stdlib.h>

#define BUF 1024
#define LINE 512
#define READ 0
#define WRITE 1

struct Cypher{
    char find[64];
    char replace[64];
};

struct Cypher* readCyphers(int *size) {
    struct Cypher *arraycypher = (struct Cypher *) malloc(sizeof(struct Cypher) * BUF);
    FILE* file = fopen("cypher.txt", "r");
    char* line = (char *) malloc(LINE);
    int aux=0;

    size_t i = 0;
    while(fgets(line, LINE, file )) {
        aux++;
        struct Cypher newcypher;

        strcpy(newcypher.find, strtok(line, " "));
        strcpy(newcypher.replace, strtok(NULL, "\n"));

        /*printf("find->%s ",newcypher.find);
        printf("replace->%s\n",newcypher.replace);*/

        arraycypher[i] = newcypher;
        i++;
    }
    *size=aux;
    return arraycypher;
}

char *replaceWord(char* buffer, char* find, char* replace, int *trocou){

    char *newbuf = (char*)malloc(BUF);
    char *newbuf_ptr = newbuf;

    *newbuf = 0;

    while(*buffer){
        if(strncmp(buffer,find, strlen(find))==0){
            strcat(newbuf_ptr, replace);
            buffer += strlen(find);
            newbuf_ptr += strlen(replace);

            *trocou = 1;
        }
        else{
            *newbuf_ptr = *buffer;
            newbuf_ptr++;
            buffer++;
        }
    }
    *newbuf_ptr = 0;
    return newbuf;

}

int main(int argc, char** argv){
    int arrayCypherSize = 0;
    struct Cypher* arrayCypher = readCyphers(&arrayCypherSize);

    pid_t pid;

    /* 2 buffers (read data in parent process and child process) */
    char *parentBuf = (char *) malloc(BUF);
    char *childBuf = (char *) malloc(BUF);

    int pipeToParent[2];
    int pipeToChild[2];

    if(pipe(pipeToParent)){
        perror("Error in pipe to Parent!\n");
        return EXIT_FAILURE;
    }

    if(pipe(pipeToChild)){
        perror("Error in pipe to Child!\n");
        return EXIT_FAILURE;
    }

    if((pid = fork()) < 0){
        perror("Fork error;\n");
        return 1;
    }

    else if(pid == 0) { /*Child process*/
        close(pipeToParent[WRITE]);
        close(pipeToChild[READ]);

        if(read(pipeToParent[READ], childBuf,BUF)<0){
            perror("Error: reading Parent process!\n");
            return EXIT_FAILURE;
        }
        close(pipeToParent[READ]);

        char* res = (char *) malloc(BUF);
        strcpy(res, childBuf);

        for(int i = 0; i < arrayCypherSize;i++){
            int trocouPalavra = 0;
            res =  replaceWord (res, arrayCypher[i].find, arrayCypher[i].replace, &trocouPalavra);
            if(!trocouPalavra){
                res =  replaceWord (res, arrayCypher[i].replace, arrayCypher[i].find, &trocouPalavra);
            }
        }
        

        if(write(pipeToChild[WRITE], res, BUF)<0){
            perror("Error: writing Parent process!\n");
            return EXIT_FAILURE;
        }
    }

    else if(pid > 0){ /*Parent Process*/
        close(pipeToChild[WRITE]);
        close(pipeToParent[READ]);

        if(read(STDIN_FILENO, parentBuf,BUF)<0){
            perror("Error: reading STDIN!\n");
            return EXIT_FAILURE;
        }

        if(write(pipeToParent[WRITE],parentBuf,strlen(parentBuf))<0){
            perror("Error: reading writing Child process!\n");
            return EXIT_FAILURE;
        }
        close(pipeToParent[WRITE]);

        if(read(pipeToChild[READ], parentBuf, BUF) < 0){
            perror("Error: reading Child process!\n");
            return 1;
        }
        close(pipeToChild[READ]);

        if (waitpid(pid, NULL, 0) < 0) {
            perror("Cannot wait for Chil!d\n");
            return EXIT_FAILURE;
        }

        printf("%s",parentBuf);
    }
    return EXIT_SUCCESS;
}